// Code generated by pulumi-language-go DO NOT EDIT.
// *** WARNING: Do not edit by hand unless you're certain you know what you are doing! ***

package pvecluster

import (
	"context"
	"reflect"

	"errors"
	"github.com/pulumi/pulumi/sdk/v3/go/pulumi"
	"internal"
)

type Node struct {
	pulumi.CustomResourceState

	Config     NodeConfigPtrOutput `pulumi:"config"`
	Connection ConnectionOutput    `pulumi:"connection"`
	Disks      DiskSpecOutput      `pulumi:"disks"`
	Host       pulumi.StringOutput `pulumi:"host"`
	Status     pulumi.StringOutput `pulumi:"status"`
}

// NewNode registers a new resource with the given unique name, arguments, and options.
func NewNode(ctx *pulumi.Context,
	name string, args *NodeArgs, opts ...pulumi.ResourceOption) (*Node, error) {
	if args == nil {
		return nil, errors.New("missing one or more required arguments")
	}

	if args.Connection == nil {
		return nil, errors.New("invalid value for required argument 'Connection'")
	}
	if args.Disks == nil {
		return nil, errors.New("invalid value for required argument 'Disks'")
	}
	if args.Host == nil {
		return nil, errors.New("invalid value for required argument 'Host'")
	}
	opts = internal.PkgResourceDefaultOpts(opts)
	var resource Node
	err := ctx.RegisterResource("pvecluster:index:Node", name, args, &resource, opts...)
	if err != nil {
		return nil, err
	}
	return &resource, nil
}

// GetNode gets an existing Node resource's state with the given name, ID, and optional
// state properties that are used to uniquely qualify the lookup (nil if not required).
func GetNode(ctx *pulumi.Context,
	name string, id pulumi.IDInput, state *NodeState, opts ...pulumi.ResourceOption) (*Node, error) {
	var resource Node
	err := ctx.ReadResource("pvecluster:index:Node", name, id, state, &resource, opts...)
	if err != nil {
		return nil, err
	}
	return &resource, nil
}

// Input properties used for looking up and filtering Node resources.
type nodeState struct {
}

type NodeState struct {
}

func (NodeState) ElementType() reflect.Type {
	return reflect.TypeOf((*nodeState)(nil)).Elem()
}

type nodeArgs struct {
	Config     *NodeConfig `pulumi:"config"`
	Connection Connection  `pulumi:"connection"`
	Disks      DiskSpec    `pulumi:"disks"`
	Host       string      `pulumi:"host"`
}

// The set of arguments for constructing a Node resource.
type NodeArgs struct {
	Config     NodeConfigPtrInput
	Connection ConnectionInput
	Disks      DiskSpecInput
	Host       pulumi.StringInput
}

func (NodeArgs) ElementType() reflect.Type {
	return reflect.TypeOf((*nodeArgs)(nil)).Elem()
}

type NodeInput interface {
	pulumi.Input

	ToNodeOutput() NodeOutput
	ToNodeOutputWithContext(ctx context.Context) NodeOutput
}

func (*Node) ElementType() reflect.Type {
	return reflect.TypeOf((**Node)(nil)).Elem()
}

func (i *Node) ToNodeOutput() NodeOutput {
	return i.ToNodeOutputWithContext(context.Background())
}

func (i *Node) ToNodeOutputWithContext(ctx context.Context) NodeOutput {
	return pulumi.ToOutputWithContext(ctx, i).(NodeOutput)
}

type NodeOutput struct{ *pulumi.OutputState }

func (NodeOutput) ElementType() reflect.Type {
	return reflect.TypeOf((**Node)(nil)).Elem()
}

func (o NodeOutput) ToNodeOutput() NodeOutput {
	return o
}

func (o NodeOutput) ToNodeOutputWithContext(ctx context.Context) NodeOutput {
	return o
}

func (o NodeOutput) Config() NodeConfigPtrOutput {
	return o.ApplyT(func(v *Node) NodeConfigPtrOutput { return v.Config }).(NodeConfigPtrOutput)
}

func (o NodeOutput) Connection() ConnectionOutput {
	return o.ApplyT(func(v *Node) ConnectionOutput { return v.Connection }).(ConnectionOutput)
}

func (o NodeOutput) Disks() DiskSpecOutput {
	return o.ApplyT(func(v *Node) DiskSpecOutput { return v.Disks }).(DiskSpecOutput)
}

func (o NodeOutput) Host() pulumi.StringOutput {
	return o.ApplyT(func(v *Node) pulumi.StringOutput { return v.Host }).(pulumi.StringOutput)
}

func (o NodeOutput) Status() pulumi.StringOutput {
	return o.ApplyT(func(v *Node) pulumi.StringOutput { return v.Status }).(pulumi.StringOutput)
}

func init() {
	pulumi.RegisterInputType(reflect.TypeOf((*NodeInput)(nil)).Elem(), &Node{})
	pulumi.RegisterOutputType(NodeOutput{})
}
